<template>
  <div class="app-container">
    <el-form ref="form" :rules="rules" :model="dataForm" label-width="100px">
      <el-form-item label="角色" prop="role">
        <!-- <el-select v-model="dataForm.role">
          <el-option v-for="(i,index) in roles" :key="index" :label="i.role" :value="i.role" />
        </el-select>-->
        <roleComponent v-model="dataForm.role" @change="changeAction" />
      </el-form-item>
      <el-form-item label="主標題" prop="title">
        <el-select v-model="dataForm.title" @change="getTreeAction">
          <el-option v-for="(i,index) in titles" :key="index" :label="i.title" :value="i.id" />
        </el-select>
        <el-button type="primary" round @click="getIdByRoleAction">查詢權限</el-button>
        <el-button v-if="showInsertBtn" type="primary" round @click="insertPermissionAction">賦予權限</el-button>
        <el-button type="primary" round @click="resetAction">重置</el-button>
      </el-form-item>
      <el-form-item label="階層">
        <el-tree
          ref="tree"
          :data="tree"
          show-checkbox
          label="title"
          children="children"
          node-key="id"
          default-expand-all
        />
      </el-form-item>
    </el-form>
  </div>
</template>
<script>
import {
  getAllRoles,
  getOneTier,
  getTress,
  addSettingPathPermission,
  getIdByRole
} from './action'
import roleComponent from '@/components/Select/Role'
import { insertFuncPermissionValid } from './rule'
export default {
  components: { roleComponent },
  data() {
    return {
      str: '',
      roles: [],
      titles: [],
      dataForm: {
        role: '',
        title: '',
        paths: [],
        excludePaths: []
      },
      tree: [],
      rules: insertFuncPermissionValid(),
      showInsertBtn: false
    }
  },
  mounted() {
    this.getAllRolesAction()
    this.getOneTierAction()
  },
  methods: {
    changeAction: function() {
      this.showInsertBtn = false
      this.$refs.tree.setCheckedKeys([])
    },
    getIdByRoleAction: function() {
      this.$refs.form.validate(valid => {
        if (valid) {
          getIdByRole({ role: this.dataForm.role }).then(res => {
            if (res.status === 'OK') {
              if (res.data.length === 0) {
                alert('查無資料!')
                this.resetAction()
                this.showInsertBtn = false
              } else {
                const arr = []
                this.checkNode(arr, this.tree, res.data)
                this.$refs.tree.setCheckedNodes(arr)
                this.showInsertBtn = true
              }
            }
          })
        }
      })
    },
    checkNode: function(arr, tree, data) {
      tree.forEach(element => {
        if (element.children) {
          this.checkNode(arr, element.children, data)
        } else if (data.includes(element.id)) {
          const json = { id: element.id, label: element.label }
          arr.push(json)
        }
      })
    },
    resetAction: function() {
      this.$nextTick(() => {
        this.$refs.form.resetFields()
        this.dataForm.paths = []
        this.dataForm.excludePaths = []
        this.tree = []
        this.showInsertBtn = false
        // const temp = Object.assign({}, this.dataForm)
        // this.dataForm = Object.assign({}, temp)
      })
    },
    popAllNodeAction: function(arr, node) {
      node.forEach(element => {
        arr.push(element.id)
        if (element.children) {
          this.popAllNodeAction(arr, element.children)
        }
      })
    },
    insertPermissionAction: function() {
      this.$refs.form.validate(valid => {
        if (valid) {
          const tree = this.$refs.tree
            .getCheckedKeys()
            .concat(this.$refs.tree.getHalfCheckedKeys())
          tree.forEach(id => {
            this.dataForm.paths.push(id)
          })

          const arr = []
          this.popAllNodeAction(arr, this.tree)
          this.dataForm.excludePaths = arr
          addSettingPathPermission(this.dataForm).then(res => {
            if (res.status === 'OK') {
              alert('執行成功!')
            } else {
              alert('執行失敗!')
            }
          })
        }
      })
    },
    getTreeAction: function() {
      getTress({ id: this.dataForm.title }).then(res => {
        this.tree = JSON.parse(res.data)
      })
    },
    getAllRolesAction: function() {
      getAllRoles().then(res => {
        this.roles = res.data
      })
    },
    getOneTierAction: function() {
      getOneTier().then(res => {
        this.titles = res.data
      })
    }
  }
}
</script>
